MAIN_PAGE_NAME   = "Final Fantasy Adventure Translation Comparison/main.html"
-- ==============================================================================================
-- INTERNAL VARIABLES FOR MISC USE
-- ==============================================================================================

engLineIDs = {}


-- ==============================================================================================
-- ==============================================================================================
-- This runs once before doLogic ever runs
function init()
	--loadHTML(TITLE_PAGE_NAME)
	resize(540, 810)
	loadHTML(MAIN_PAGE_NAME)
	callJSFunction("clearAllData")
end


-- ==============================================================================================
-- ==============================================================================================
-- This handles messages sent by the emulator, like if the player presses certain buttons or
-- other events happen within the emulator itself
function getMessage(str)
	if str == "resetgame" then
		init()
	elseif str == "loadstate" then
		loadHTML(MAIN_PAGE_NAME)
		callJSFunction("clearAllData")
	end
end


-- ==============================================================================================
-- ==============================================================================================
-- All main logic goes in here & gets called once per CPU cycle
function doLogic()
	
end


-- when a 04 is hit
--    check current bank
--    get current address
--    use current address to find out the parent-sub ID, hopefully lua has arrays that do this easily
--    display the Japanese text that has the same parent-sub ID 

--    close script window when a closewin code is hit? or 0?


-- GAME IS ABOUT TO LOAD A SCRIPT LINE, SO LET'S DISPLAY THE JAPANESE EQUIVALENT
--[[function PC_31EA()
	local lineNum = getHL()
	if lineNum == 3 then -- just making it prettier when going from the intro story to the naming screen
		callJSFunction("closeScriptDiv")
	else
		callJSFunction_Str("displayScriptDiv", "#sd1comp-script-" .. lineNum)
	end
end

-- GAME IS ABOUT TO LOAD A BLOCK OF TEXT VIA THE 02 GOSUB/GOTO CONTROL CODE, SO LET'S GRAB THAT OFFSET AND DISPLAY THE APPROPRIATE LINE
function PC_3304()
	local offset = getDE()
	offset = string.format("%04X", offset)
	callJSFunction_Str2("prependSecondaryScriptArea", "#sd1comp-addr-" .. offset, "#secondaryscriptarea")
end
]]--

-- GAME IS ABOUT TO LOAD ITEM NAMES, SPELL NAMES, OR OTHER MENU TEXT
function PC_75ED()
	local itemNum = getA() & 0x7F
	
	-- DEPENDING ON THE SITUATION, SO WE'LL COMPENSATE AND CHANGE THE ITEM NUMBER TO MATCH AS NEEDED
	local baseItemDataStart = 0x5DDB
	local currItemDataStart = getHL() + 1
	local diff = currItemDataStart - baseItemDataStart
	diff = diff // 16
	itemNum = itemNum + diff
	callJSFunction_Str2("appendHTMLElement", "#sd1-item-" .. itemNum, "#itemarea")
	callJSFunction_Int("addItemPic", itemNum)
end

-- GAME IS ABOUT TO CLOSE A TEXT WINDOW OR DO OTHER SIMILAR STUFF, SO LET'S DO SOMETHING WITH THE SIDEBAR TOO
function PC_335E()
	-- this function actually gets called whenever a control code is in the 1X range	
	local controlCode = getA()
	
	-- THE GAME IS ABOUT TO CLOSE A TEXT WINDOW
	if controlCode == 0x11 then
		callJSFunction("closeScriptDiv")
		callJSFunction("clearAllData")
	-- THE GAME JUST HIT A WAIT CODE
	elseif controlCode == 0x12 then
		--saveScreenshot()
	end
end


-- we're about to move to a new screen
function PC_21C1()
	callJSFunction("clearAllData")
end

-- JUST TO BE SURE, WE'LL ALSO CLOSE TEXT WINDOWS WHEN AN END-OF-LINE CONTROL CODE IS REACHED
--[[function PC_32A4()
	local readLocation = getHL()
	local controlCode = getA()
	local d = getD()
	
	if controlCode == 0x00 then
		if readLocation == 0xD616 then return end -- manually adding stuff so that certain key lines don't get immediately erased

		-- gotta make it so screen transitions only clear stuff as needed
		local moveStatus = getMemory(0xD86E, 1)	-- this gets set to stuff when we're moving
		if moveStatus == 0 and readLocation > 0x4000 and readLocation < 0x5000 then return end
		
		callJSFunction("clearAllData")
	end
end]]--

function PC_3728()
	local controlCode = getA()
	local currLoc = getHL()

	if controlCode == 0x04 then
		-- we need to check which bank we're in, the main script bank or the secondary script bank
		-- we'll compensate for the second bank if necessary
		local bankCheck = getMemory(0x4000, 2)
		if bankCheck == 0xC90B then
			currLoc = currLoc + 0x4000
		end
		
		if engLineIDs[currLoc] ~= nil then
			local followingControlCode = getMemory(currLoc, 1)
			callJSFunction("clearAllData")
				callJSFunction_Str("displayScriptDiv", "#sd1-script-" .. engLineIDs[currLoc])
			
			--[[if followingControlCode == 0x10 then -- let's clear the sidebar text area if we're about to clear the window in the game
				callJSFunction("clearAllData")
				callJSFunction_Str("displayScriptDiv", "#sd1-script-" .. engLineIDs[currLoc])
			else -- otherwise let's append the new text to the existing text, this might cause issues but we'll find out
				callJSFunction("clearAllTextExceptScript")
				callJSFunction_Str2("appendScript", "#sd1-script-" .. engLineIDs[currLoc], "#scriptarea")
			end]]--

			
			
			
		else
			local currLocStr = string.format("%04X", currLoc)
			--writeHTML("scriptarea", "-line " .. currLocStr .. " not found-")
		end
	end
end


-- A MENU IS ABOUT TO OPEN, SO LET'S CLEAR THE SIDEBAR
function PC_68D2()
	callJSFunction("clearAllData")
end


-- A MENU CURSOR IS ABOUT TO MOVE, SO LET'S MAYBE CLEAR THE SIDEBAR?
function PC_682F()
	--callJSFunction("clearAllData")
end

-- A MENU IS ABOUT TO CLOSE, SO LET'S CLEAR THE SIDEBAR
function PC_68D2()
	callJSFunction("clearAllData")
end

-- SHOP MENU OR OTHER MENU IS SCROLLING DOWN, SO LET'S CLEAR THE SIDEBAR BEFORE WE RELOAD THE TEXT
function PC_6A20()
	callJSFunction("clearAllData")
end

-- SHOP MENU OR OTHER MENU IS SCROLLING UP, SO LET'S CLEAR THE SIDEBAR BEFORE WE RELOAD THE TEXT
function PC_6A8C()
	callJSFunction("clearAllData")
end


-- WE'RE ABOUT TO LOAD SOME MISC TEXT, SO LET'S DISPLAY THE JAPANESE EQUIVALENT
function PC_5B6C()
	local offset = getHL()
	offset = string.format("%04X", offset)
	--callJSFunction_Str2("appendHTMLElement", "#sd1comp-misc-addr-" .. offset, "#misctextarea")
end

-- WE'RE ABOUT TO LOAD SOME MISC TEXT, SO LET'S DISPLAY THE JAPANESE EQUIVALENT
function PC_3777()
	local offset = getHL()
	
	-- let's clear the sidebar between the story roll and the naming screen
	if offset == 0x7DF9 then
		callJSFunction("clearAllData")
	end
	
	offset = string.format("%04X", offset)
	callJSFunction_Str2("appendHTMLElement", "#sd1comp-misc-addr-" .. offset, "#misctextarea")
end

-- WE'RE ABOUT TO DISPLAY THE INTRO STORY, SO LET'S SHOW THE JAPANESE ONE TOO
function PC_7C24()
	callJSFunction_Str("displayScriptDiv", "#sd1-intro-story")
end


-- AN ENEMY JUST TOOK DAMAGE SO LET'S DISPLAY INFO ABOUT THE ENEMY, NOTE THAT THIS ASM IS IN ROM BANK 3, DUNNO HOW TO CHECK THAT THOUGH
function PC_4A25()
	-- we need to make sure this is happening while in bank 3, so here's a weird workaround
	local bankCheck = getMemory(0x4A25, 2)
	if bankCheck ~= 0xD5C9 then return end -- leave if this isn't the right spot
	
	local currEnemyDataPtr = getHL() + 3 -- HL is currently pointing to the 2nd byte in the current enemy's current HP, 3 bytes over is the ID we need
	local enemyStatBlockPtr = getMemory(currEnemyDataPtr, 2)
	local currEnemyID = (enemyStatBlockPtr - 0x59FE)
	currEnemyID = currEnemyID // 0xE
	
	-- enemies 48 and 49 are weird and we need to swap their IDs
	if currEnemyID == 48 then
		currEnemyID = 49
	elseif currEnemyID == 49 then
		currEnemyID = 48
	end

	callJSFunction_Str2("addEnemyProfile", currEnemyID, 0)
end

-- WE'RE ABOUT TO LOAD A NEW ENEMY FOR THE NEW SCREEN, SO LET'S DISPLAY IT ON THE SIDEBAR AS NEEDED
function PC_42FD()
	-- we need to make sure this is happening while in bank 3, so here's a weird workaround
	local bankCheck = getMemory(0x42FD, 2)
	if bankCheck ~= 0x2371 then return end -- leave if this isn't the right spot

	local enemyStatBlockPtr = getBC()
	local currEnemyID = (enemyStatBlockPtr - 0x59FE)
	currEnemyID = currEnemyID // 0xE
	
	-- enemies 48 and 49 are weird and we need to swap their IDs
	if currEnemyID == 48 then
		currEnemyID = 49
	elseif currEnemyID == 49 then
		currEnemyID = 48
	end
	
	callJSFunction_Str2("addEnemyProfile", currEnemyID, 0)
end

currBossID = -1
-- WE'RE ABOUT TO FIGHT A BOSS, SO LET'S PUT UP THE BOSS INFO!
function PC_42F7()
	-- we need to make sure this is happening while in bank 4, so here's a weird workaround
	local bankCheck = getMemory(0x42F7, 2)
	if bankCheck ~= 0x266F then
		return
	end -- leave if this isn't the right spot
	
	local bossID = getA()
	currBossID = bossID -- saving this in global variable so we can use this later
	callJSFunction_Str2("addEnemyProfile", "boss-" .. bossID, 0)
end

-- UPDATE CURR BOSS' HP
function PC_4727()
	-- we need to make sure this is happening while in bank 4, so here's a weird workaround
	local bankCheck = getMemory(0x4727, 2)
	if bankCheck ~= 0x3Ec9 then
		return
	end -- leave if this isn't the right spot
	
	callJSFunction_Str2("addEnemyProfile", "boss-" .. currBossID, 0)
	
	local currBossHP = getMemory(0xD3F4, 2)
	if currBossHP < 0 or currBossHP >= 0x7FFF then
		currBossHP = 0	
	end
	
	callJSFunction_Int("updateBossHP", currBossHP)
end

-- LET'S MAKE A COPY OF THE CURRENT SAVE (FOR LATER USE/REFERENCE) EACH TIME WE SAVE THE GAME MANUALLY
function PC_7299()
	writeSaveFile()
	displayEmuMessage("Save archived")
end



--3c6F SETS ff TO D85A, WHICH SEEMS TO BE THE CURRENT PROCESSED SCRIPT CHAR, FF SEEMS TO BE THE "WAIT FOR INPUT" MODE
--36DB SETS TO 4, HAPPENS WHEN DOING ANYTHING THAT INVOLVES PRINTING TEXT TO WINDOW, CAN SKIP THIS
--32A4 SETS TO 0 AT END OF LINE?

function initializeEtoJArray()
	engLineIDs[0x413B] = "5-0"
	engLineIDs[0x4160] = "7-0"
	engLineIDs[0x4228] = "9-0"
	engLineIDs[0x4260] = "12-1"
	engLineIDs[0x428F] = "12-2"
	engLineIDs[0x42C9] = "12-3"
	engLineIDs[0x438F] = "13-0"
	engLineIDs[0x4397] = "13-1"
	engLineIDs[0x439C] = "13-2"
	engLineIDs[0x46E3] = "230-0"
	engLineIDs[0x47A9] = "245-0"
	engLineIDs[0x487F] = "271-0"
	engLineIDs[0x4963] = "286-0"
	engLineIDs[0x499C] = "288-0"
	engLineIDs[0x49BA] = "288-1"
	engLineIDs[0x49C9] = "288-2"
	engLineIDs[0x49E2] = "288-3"
	engLineIDs[0x4A1A] = "288-4"
	engLineIDs[0x4A3F] = "288-5"
	engLineIDs[0x4AEE] = "320-0"
	engLineIDs[0x4B6C] = "340-0"
	engLineIDs[0x4C88] = "413-0"
	engLineIDs[0x4C95] = "413-1"
	engLineIDs[0x4C9B] = "413-2"
	engLineIDs[0x4DE9] = "421-0"
	engLineIDs[0x4E15] = "421-1"
	engLineIDs[0x4E3F] = "421-2"
	engLineIDs[0x4E7D] = "422-0"
	engLineIDs[0x4EBC] = "424-0"
	engLineIDs[0x4ECF] = "424-1"
	engLineIDs[0x4EF5] = "424-2"
	engLineIDs[0x4F1C] = "424-3"
	engLineIDs[0x4F6A] = "427-0"
	engLineIDs[0x4F86] = "428-0"
	engLineIDs[0x4FE4] = "430-0"
	engLineIDs[0x5027] = "430-1"
	engLineIDs[0x506F] = "431-0"
	engLineIDs[0x50AF] = "433-0"
	engLineIDs[0x50E0] = "433-1"
	engLineIDs[0x5124] = "433-2"
	engLineIDs[0x516B] = "433-3"
	engLineIDs[0x51D4] = "433-4"
	engLineIDs[0x5225] = "436-0"
	engLineIDs[0x5261] = "439-0"
	engLineIDs[0x5273] = "439-1"
	engLineIDs[0x52C2] = "442-0"
	engLineIDs[0x52D5] = "442-1"
	engLineIDs[0x531B] = "443-0"
	engLineIDs[0x535C] = "443-1"
	engLineIDs[0x53A1] = "443-2"
	engLineIDs[0x53CE] = "445-0"
	engLineIDs[0x53EE] = "445-1"
	engLineIDs[0x53F6] = "445-2"
	engLineIDs[0x53FB] = "445-3"
	engLineIDs[0x544B] = "448-0"
	engLineIDs[0x5481] = "451-0"
	engLineIDs[0x54B8] = "454-0"
	engLineIDs[0x54EC] = "457-0"
	engLineIDs[0x5522] = "460-0"
	engLineIDs[0x5536] = "460-1"
	engLineIDs[0x5570] = "480-0"
	engLineIDs[0x55DD] = "480-2"
	engLineIDs[0x55EB] = "480-3"
	engLineIDs[0x55FA] = "480-4"
	engLineIDs[0x5617] = "480-5"
	engLineIDs[0x563B] = "481-0"
	engLineIDs[0x5680] = "482-0"
	engLineIDs[0x56C0] = "483-0"
	engLineIDs[0x56E9] = "484-0"
	engLineIDs[0x577C] = "486-0"
	engLineIDs[0x579E] = "487-0"
	engLineIDs[0x57B8] = "488-0"
	engLineIDs[0x57D5] = "489-0"
	engLineIDs[0x582E] = "490-0"
	engLineIDs[0x5844] = "491-0"
	engLineIDs[0x5870] = "492-1"
	engLineIDs[0x587E] = "492-2"
	engLineIDs[0x58CA] = "493-0"
	engLineIDs[0x58F3] = "494-1"
	engLineIDs[0x5914] = "494-2"
	engLineIDs[0x593F] = "495-1"
	engLineIDs[0x59F6] = "496-0"
	engLineIDs[0x5B28] = "496-1"
	engLineIDs[0x5B76] = "498-0"
	engLineIDs[0x5B9A] = "499-1"
	engLineIDs[0x5BB0] = "499-2"
	engLineIDs[0x5BD5] = "500-1"
	engLineIDs[0x5BF7] = "500-2"
	engLineIDs[0x5C32] = "500-3"
	engLineIDs[0x5C4C] = "501-0"
	engLineIDs[0x5C88] = "502-1"
	engLineIDs[0x5CBF] = "502-2"
	engLineIDs[0x5CDE] = "504-0"
	engLineIDs[0x5D2C] = "505-0"
	engLineIDs[0x5D79] = "510-1"
	engLineIDs[0x5D9A] = "510-2"
	engLineIDs[0x5DEA] = "510-3"
	engLineIDs[0x5E0A] = "511-0"
	engLineIDs[0x5E37] = "512-0"
	engLineIDs[0x5E51] = "514-0"
	engLineIDs[0x5E6D] = "515-0"
	engLineIDs[0x5EB3] = "516-0"
	engLineIDs[0x5ECD] = "517-0"
	engLineIDs[0x5F13] = "518-0"
	engLineIDs[0x5F2D] = "519-0"
	engLineIDs[0x5F89] = "519-1"
	engLineIDs[0x5FE0] = "520-0"
	engLineIDs[0x603E] = "520-1"
	engLineIDs[0x608D] = "520-2"
	engLineIDs[0x6099] = "520-3"
	engLineIDs[0x60B5] = "520-4"
	engLineIDs[0x60C5] = "520-5"
	engLineIDs[0x6100] = "521-0"
	engLineIDs[0x6124] = "523-0"
	engLineIDs[0x6136] = "525-0"
	engLineIDs[0x617D] = "526-0"
	engLineIDs[0x61AE] = "527-1"
	engLineIDs[0x61B7] = "527-2"
	engLineIDs[0x6207] = "527-3"
	engLineIDs[0x622B] = "527-4"
	engLineIDs[0x623F] = "528-0"
	engLineIDs[0x637F] = "529-0"
	engLineIDs[0x63BE] = "530-0"
	engLineIDs[0x63F9] = "531-0"
	engLineIDs[0x643A] = "532-0"
	engLineIDs[0x647D] = "533-0"
	engLineIDs[0x64A3] = "534-0"
	engLineIDs[0x64CA] = "535-0"
	engLineIDs[0x64D3] = "535-1"
	engLineIDs[0x64F1] = "535-2"
	engLineIDs[0x6510] = "535-3"
	engLineIDs[0x6533] = "535-4"
	engLineIDs[0x654D] = "535-5"
	engLineIDs[0x6574] = "536-0"
	engLineIDs[0x65F4] = "537-0"
	engLineIDs[0x661C] = "537-2"
	engLineIDs[0x6646] = "538-0"
	engLineIDs[0x6659] = "538-1"
	engLineIDs[0x667E] = "539-1"
	engLineIDs[0x669E] = "539-2"
	engLineIDs[0x66D3] = "540-0"
	engLineIDs[0x66F7] = "541-0"
	engLineIDs[0x671B] = "542-0"
	engLineIDs[0x6767] = "543-0"
	engLineIDs[0x6787] = "544-0"
	engLineIDs[0x67ED] = "545-0"
	engLineIDs[0x682A] = "545-1"
	engLineIDs[0x683D] = "545-2"
	engLineIDs[0x685E] = "546-0"
	engLineIDs[0x6878] = "550-0"
	engLineIDs[0x68A3] = "551-1"
	engLineIDs[0x68B2] = "551-2"
	engLineIDs[0x68E2] = "551-3"
	engLineIDs[0x698E] = "551-4"
	engLineIDs[0x69DA] = "551-5"
	engLineIDs[0x69ED] = "551-6"
	engLineIDs[0x6A0D] = "552-0"
	engLineIDs[0x6A50] = "553-1"
	engLineIDs[0x6A71] = "553-2"
	engLineIDs[0x6A90] = "553-3"
	engLineIDs[0x6AC1] = "554-1"
	engLineIDs[0x6AC7] = "554-2"
	engLineIDs[0x6ACD] = "554-3"
	engLineIDs[0x6C1C] = "555-1"
	engLineIDs[0x6C40] = "555-2"
	engLineIDs[0x6CAD] = "556-1"
	engLineIDs[0x6CC4] = "556-2"
	engLineIDs[0x6CE7] = "557-0"
	engLineIDs[0x6D02] = "558-0"
	engLineIDs[0x6D1E] = "558-1"
	engLineIDs[0x6D26] = "559-0"
	engLineIDs[0x6D31] = "559-1"
	engLineIDs[0x6D74] = "559-2"
	engLineIDs[0x6D81] = "559-3"
	engLineIDs[0x6DBD] = "559-4"
	engLineIDs[0x6E1E] = "560-0"
	engLineIDs[0x6E77] = "561-1"
	engLineIDs[0x6E9B] = "562-0"
	engLineIDs[0x6FED] = "563-0"
	engLineIDs[0x705E] = "564-0"
	engLineIDs[0x7077] = "564-1"
	engLineIDs[0x7087] = "565-0"
	engLineIDs[0x70D1] = "566-0"
	engLineIDs[0x711D] = "567-0"
	engLineIDs[0x7155] = "574-0"
	engLineIDs[0x7185] = "575-0"
	engLineIDs[0x71B3] = "576-0"
	engLineIDs[0x7212] = "577-0"
	engLineIDs[0x7243] = "578-0"
	engLineIDs[0x72BC] = "579-0"
	engLineIDs[0x7330] = "580-0"
	engLineIDs[0x735D] = "581-0"
	engLineIDs[0x7433] = "585-0"
	engLineIDs[0x7460] = "585-1"
	engLineIDs[0x7489] = "585-2"
	engLineIDs[0x74A1] = "585-3"
	engLineIDs[0x74DA] = "585-4"
	engLineIDs[0x75C5] = "585-5"
	engLineIDs[0x75DB] = "585-6"
	engLineIDs[0x75F6] = "585-7"
	engLineIDs[0x7622] = "592-1"
	engLineIDs[0x76AD] = "592-2"
	engLineIDs[0x76D6] = "593-0"
	engLineIDs[0x76E3] = "594-0"
	engLineIDs[0x76F6] = "595-0"
	engLineIDs[0x77DF] = "607-0"
	engLineIDs[0x7808] = "607-1"
	engLineIDs[0x7856] = "608-0"
	engLineIDs[0x7884] = "608-1"
	engLineIDs[0x7891] = "608-2"
	engLineIDs[0x789C] = "608-3"
	engLineIDs[0x78AB] = "609-0"
	engLineIDs[0x78FA] = "612-0"
	engLineIDs[0x7912] = "613-0"
	engLineIDs[0x7943] = "614-0"
	engLineIDs[0x7961] = "615-0"
	engLineIDs[0x7989] = "616-0"
	engLineIDs[0x79CD] = "617-0"
	engLineIDs[0x7A13] = "618-0"
	engLineIDs[0x7A54] = "619-0"
	engLineIDs[0x7A7F] = "620-1"
	engLineIDs[0x7B18] = "621-0"
	engLineIDs[0x7B41] = "621-1"
	engLineIDs[0x7B82] = "621-2"
	engLineIDs[0x7BAE] = "624-0"
	engLineIDs[0x7C3A] = "629-0"
	engLineIDs[0x7C9B] = "633-0"
	engLineIDs[0x7D00] = "634-0"
	engLineIDs[0x7D0F] = "634-1"
	engLineIDs[0x7D31] = "634-2"
	engLineIDs[0x7DF1] = "641-1"
	engLineIDs[0x7E34] = "642-0"
	engLineIDs[0x800A] = "660-0"
	engLineIDs[0x8094] = "666-0"
	engLineIDs[0x80B8] = "667-0"
	engLineIDs[0x818D] = "671-0"
	engLineIDs[0x8350] = "702-0"
	engLineIDs[0x8931] = "850-0"
	engLineIDs[0x896B] = "850-1"
	engLineIDs[0x8E41] = "966-0"
	engLineIDs[0x8E5F] = "966-1"
	engLineIDs[0x8E9E] = "966-2"
	engLineIDs[0x8EB2] = "966-3"
	engLineIDs[0x8F4E] = "982-0"
	engLineIDs[0x9162] = "1025-0"
	engLineIDs[0x9198] = "1025-1"
	engLineIDs[0x91FE] = "1029-0"
	engLineIDs[0x923D] = "1034-0"
	engLineIDs[0x9273] = "1034-1"
	engLineIDs[0x9393] = "1070-0"
	engLineIDs[0x93AD] = "1071-0"
	engLineIDs[0x93C6] = "1072-0"
	engLineIDs[0x93E1] = "1073-0"
	engLineIDs[0x93FC] = "1074-0"
	engLineIDs[0x9418] = "1076-0"
	engLineIDs[0x942C] = "1077-0"
	engLineIDs[0x9449] = "1077-1"
	engLineIDs[0x94C4] = "1079-0"
	engLineIDs[0x9509] = "1080-0"
	engLineIDs[0x9527] = "1081-0"
	engLineIDs[0x9544] = "1082-0"
	engLineIDs[0x955A] = "1083-0"
	engLineIDs[0x9573] = "1084-0"
	engLineIDs[0x9589] = "1085-0"
	engLineIDs[0x95A0] = "1086-0"
	engLineIDs[0x95B9] = "1088-0"
	engLineIDs[0x95D0] = "1089-0"
	engLineIDs[0x95E8] = "1090-0"
	engLineIDs[0x95FF] = "1091-0"
	engLineIDs[0x961E] = "1092-0"
	engLineIDs[0x9630] = "1092-1"
	engLineIDs[0x964A] = "1093-0"
	engLineIDs[0x9667] = "1094-0"
	engLineIDs[0x967F] = "1095-0"
	engLineIDs[0x9698] = "1096-0"
	engLineIDs[0x96B0] = "1097-0"
	engLineIDs[0x96C9] = "1098-0"
	engLineIDs[0x96E9] = "1099-0"
	engLineIDs[0x970F] = "1101-0"
	engLineIDs[0x9728] = "1101-1"
	engLineIDs[0x9748] = "1102-0"
	engLineIDs[0x9762] = "1102-1"
	engLineIDs[0x9780] = "1103-0"
	engLineIDs[0x979A] = "1103-1"
	engLineIDs[0x97AD] = "1104-0"
	engLineIDs[0x97D7] = "1105-0"
	engLineIDs[0x97EC] = "1105-1"
	engLineIDs[0x9842] = "1106-0"
	engLineIDs[0x985A] = "1107-0"
	engLineIDs[0x9873] = "1109-0"
	engLineIDs[0x988B] = "1110-0"
	engLineIDs[0x98A2] = "1111-0"
	engLineIDs[0x98BA] = "1112-0"
	engLineIDs[0x98D4] = "1113-0"
	engLineIDs[0x98ED] = "1114-0"
	engLineIDs[0x9906] = "1115-0"
	engLineIDs[0x991E] = "1116-0"
	engLineIDs[0x9935] = "1117-0"
	engLineIDs[0x994E] = "1118-0"
	engLineIDs[0x9967] = "1119-0"
	engLineIDs[0x9981] = "1120-0"
	engLineIDs[0x9999] = "1121-0"
	engLineIDs[0x99B2] = "1122-0"
	engLineIDs[0x99CC] = "1123-0"
	engLineIDs[0x99E6] = "1124-0"
	engLineIDs[0x9A06] = "1126-0"
	engLineIDs[0x9A31] = "1127-0"
	engLineIDs[0x9A4D] = "1136-0"
	engLineIDs[0x9A91] = "1138-0"
	engLineIDs[0x9AE3] = "1139-0"
	engLineIDs[0x9C10] = "1200-0"
	engLineIDs[0x9CB8] = "1241-0"
	engLineIDs[0x9FFB] = "1298-0"
	engLineIDs[0xA038] = "1301-0"
	engLineIDs[0xA133] = "1329-0"
	engLineIDs[0xA15B] = "1329-2"
	engLineIDs[0xA1A0] = "1330-0"
	engLineIDs[0xA1D1] = "1330-1"
	engLineIDs[0xA1E6] = "1330-2"
	engLineIDs[0xA1FB] = "1331-0"
	engLineIDs[0xA26F] = "1331-1"
	engLineIDs[0xA283] = "1331-2"
	engLineIDs[0xA28F] = "1331-3"
	engLineIDs[0xA29C] = "1331-4"
	engLineIDs[0xA2C0] = "1332-0"
	engLineIDs[0xA2EA] = "1332-1"
	engLineIDs[0xA319] = "1332-2"
	engLineIDs[0xA340] = "1332-3"
	engLineIDs[0xA35C] = "1332-4"
	engLineIDs[0xA391] = "1332-5"
	engLineIDs[0xA3F7] = "1333-1"
	engLineIDs[0xA44C] = "1334-0"
	engLineIDs[0xA4B0] = "1334-1"
	engLineIDs[0xA4E2] = "1335-0"
	engLineIDs[0xA4FA] = "1335-1"
	engLineIDs[0xA52A] = "1335-3"
	engLineIDs[0xA539] = "1335-4"
	engLineIDs[0xA575] = "1335-5"
	engLineIDs[0xA57C] = "1335-6"
	engLineIDs[0xA588] = "1335-7"
	engLineIDs[0xA5A8] = "1335-8"
	engLineIDs[0xA5D1] = "1335-9"
	engLineIDs[0xA60E] = "1335-10"
	engLineIDs[0xA64D] = "1335-11"
	engLineIDs[0xA68E] = "1336-0"
	engLineIDs[0xA69A] = "1336-1"
	engLineIDs[0xA6BC] = "1336-2"
	engLineIDs[0xA6C2] = "1336-3"
	engLineIDs[0xA6C7] = "1336-4"
	engLineIDs[0xA704] = "1336-5"
	engLineIDs[0xA767] = "1337-0"
	engLineIDs[0xA78A] = "1337-1"
	engLineIDs[0xA7E9] = "1337-2"
	engLineIDs[0xA810] = "1337-3"
	engLineIDs[0xA8EC] = "1338-0"
	engLineIDs[0xAA34] = "1338-1"
	engLineIDs[0xAA54] = "1338-3"
	engLineIDs[0xAA78] = "1338-4"
	engLineIDs[0xAACE] = "1338-5"
	engLineIDs[0xAB0A] = "1339-0"
	engLineIDs[0xAB13] = "1339-1"
	engLineIDs[0xAB47] = "1339-2"
	engLineIDs[0xABEE] = "1339-3"
	engLineIDs[0xAC27] = "1339-4"
	engLineIDs[0xAC53] = "1339-5"
	engLineIDs[0xAC77] = "1339-6"
	engLineIDs[0xAC88] = "1339-7"
	engLineIDs[0xACC3] = "1339-8"
	engLineIDs[0xACE9] = "1339-9"
	engLineIDs[0xAD0D] = "1339-10"
	engLineIDs[0xAD33] = "1340-0"
	engLineIDs[0xAD56] = "1340-1"
	engLineIDs[0xADDF] = "1340-2"
	engLineIDs[0xADFA] = "1341-0"
	engLineIDs[0xAEDE] = "1342-0"
	engLineIDs[0xAEF4] = "1342-1"
	engLineIDs[0xAF5B] = "1342-2"
	engLineIDs[0xAF8B] = "1342-3"
	engLineIDs[0xAFEC] = "1343-0"
	engLineIDs[0xB006] = "1343-1"
	engLineIDs[0xB02F] = "1343-3"
	engLineIDs[0xB03E] = "1343-4"
	engLineIDs[0xB045] = "1343-5"
	engLineIDs[0xB05F] = "1343-7"
	engLineIDs[0xB0A6] = "1343-8"
	engLineIDs[0xB1ED] = "1344-0"
	engLineIDs[0xB1F4] = "1344-1"
	engLineIDs[0xB1FE] = "1344-2"
	engLineIDs[0xB217] = "1344-3"
	engLineIDs[0xB239] = "1344-4"
	engLineIDs[0xB25E] = "1344-5"
	engLineIDs[0xB285] = "1344-6"
	engLineIDs[0xB2A8] = "1344-7"
	engLineIDs[0xB2C8] = "1344-9"
	engLineIDs[0xB2E7] = "1344-10"
	engLineIDs[0xB30C] = "1344-11"
	engLineIDs[0xB326] = "1344-12"
	engLineIDs[0xB348] = "1344-13"
	engLineIDs[0xB36B] = "1344-15"
	engLineIDs[0xB383] = "1344-17"
	engLineIDs[0xB38F] = "1344-18"
	engLineIDs[0xB3AF] = "1344-20"
	engLineIDs[0xB3BD] = "1344-21"
	engLineIDs[0xB3EA] = "1344-24"
	engLineIDs[0xB3F8] = "1344-25"
	engLineIDs[0xB401] = "1344-26"
	engLineIDs[0xB413] = "1345-0"
	engLineIDs[0xB435] = "1345-1"
	engLineIDs[0xB457] = "1345-2"
	engLineIDs[0xB470] = "1345-3"
	engLineIDs[0xB4B3] = "1345-5"
	engLineIDs[0xB4E9] = "1345-7"
	engLineIDs[0xB511] = "1345-9"
	engLineIDs[0xB56C] = "1345-11"
	engLineIDs[0xB5B1] = "1345-13"
	engLineIDs[0xB5D4] = "1345-15"
	engLineIDs[0xB617] = "1345-17"
	engLineIDs[0xB63C] = "1345-19"
	engLineIDs[0xB66B] = "1345-21"
	engLineIDs[0xB6CB] = "1345-23"
	engLineIDs[0xB9CE] = "1352-0"
	engLineIDs[0xB9D7] = "1352-1"
	engLineIDs[0xB9DE] = "1352-2"
	engLineIDs[0xBA2E] = "1352-3"
	engLineIDs[0xBA5D] = "1352-4"
	engLineIDs[0xBA76] = "1352-5"
	engLineIDs[0xBA9C] = "1352-7"
	engLineIDs[0xBAC3] = "1353-0"
	engLineIDs[0xBAFD] = "1353-3"
	engLineIDs[0xBB1B] = "1353-4"
	engLineIDs[0xBB28] = "1353-6"
end

initializeEtoJArray()