// *********************************************************************************
// ESSENTIAL INTERNAL ROUTINES
// *********************************************************************************

// =================================================================================
// 
// =================================================================================
function replaceHtml(el, html) {
	var oldEl = typeof el === "string" ? document.getElementById(el) : el;
	var newEl = oldEl.cloneNode(false);
	newEl.innerHTML = html;
	oldEl.parentNode.replaceChild(newEl, oldEl);
	return newEl;
};


function writeHTML(id, msg)
{
	replaceHtml(id, msg);
}
	

// =================================================================================
// Copy the contents of one HTML element into another
// The destination's previous contents are overwritten
// =================================================================================
function copyHTMLElement(source, destination)
{
	$(destination).html($(source).html());
}


// =================================================================================
// Move the contents of one HTML element into another
// The source's current contents are removed
// The destination's previous contents are overwritten
// =================================================================================
function moveHTMLElement(source, destination)
{
	$(destination).html($(source).detach().html());
	//$(source).appendTo(destination);
	/*var s = $(source);
	var h = s.html();
	s.empty();
	$(destination).html(h);*/
	//$(source).detach().html(destination);
	//$(destination).show()
}


// =================================================================================
// Append content of source div to content of destination div
// Since this uses jQuery, IDs need to use #
// The copied HTML content is wrapped in a div for convenience purposes
// =================================================================================
function appendHTMLElement(source, destination)
{
	var s = $(source).html();
	if (s == null || s == "")
	{
	}
	else
	{
		$(destination).append("<div class=\"" + $(source).attr("id") + "\">" + s + "</div>");
	}
}

function appendHTMLContent(source, destination)
{
	$(destination).append($(source).html());
}

function prependHTMLElement(source, destination)
{
	var s = $(source).html();
	if (s == null || s == "")
	{
	}
	else
	{
		$(destination).prepend("<div class=\"" + $(source).attr("id") + "\">" + s + "</div>");
	}
}

function prependSecondaryScriptArea(source, destination)
{
	var dropTime = 200;
	var s = $(source).html();
	if (s == null || s == "")
	{
	}
	else
	{
		var glowout = "";
		if ($(destination + " > div").length > 0)
		{
			glowout = "glowout";
		}
		
		$(destination).prepend("<div></div>");
		$(destination + " div:first").hide().html("<div class=\"" + $(source).attr("id") + " " + glowout + "\">" + s + "<hr /></div>").slideDown(dropTime);
	}
}

function appendScript(source, destination)
{
	var dropTime = 200;
	var s = $(source).html();
	if (s == null || s == "")
	{
	}
	else
	{
		var glowout = "";
		if ($(destination + " > div").length > 0)
		{
			glowout = "glowout";
			s = "<hr />" + s;
		}
		
		$(destination).show();
		//$(destination).append("<div></div>");
		$(destination).append("<div class=\"appended-line " + $(source).attr("id") + " " + glowout + "\">" + s + "</div>");
		$(destination + " .appended-line:list").hide().slideDown(dropTime);
		//$(destination).show();
		//$(destination + " div:last").slideDown(dropTime);
	}
}

// *********************************************************************************
// GAME-SPECIFIC ROUTINES
// *********************************************************************************


// =================================================================================
// A super-helpful way to clear the main viewing area of all text
// =================================================================================

function clearAllData()
{
	$("#container > div").html("");
	$("#container > div").show();
}





// =================================================================================
// A handy way to copy a div into the script area and have it display in a fancy way
// =================================================================================
dropTime = 0;
function displayScriptDiv(source)
{
	//window.clearTimeout(scriptCloseTimer);
	dropTime = 200;
	var s = $(source).html();
	if (s == null || s == "")
	{
		/*s = "<div class=\"notext\">-NO TEXT-</div>";
		dropTime = 0;*/
	}
	else
	{
		$("#scriptarea").hide().html(s);
		$("#scriptarea").slideDown(dropTime);
	}
	
	/*$("#scriptarea").hide().html(s);
	
	$("#scriptarea").attr("class", "");
	$("#scriptarea").attr("class", $(source).attr("class") + " " + $(source).attr("id"));*/


}


// =================================================================================
// Close the script area in a fancy way
// =================================================================================
function closeScriptDiv()
{
	$("#scriptarea").slideUp(100);
	$("#scriptarea").removeClass("nodelay");
}


function clearItemDiv()
{
	$("#itemarea").html("");
}


function clearScriptDiv()
{
	$("#scriptarea").html("");
}

function clearMiscTextDiv()
{
	$("#misctextarea").html("");
}

function addEnemyProfile(enemyID, delay)
{
	var s = $("#enemy-info-" + enemyID).html();
	if (s == null || s == "")
	{
	}
	else
	{
		var alreadyExists = $("#enemyarea > .enemy-info-" + enemyID).html();
		var totalEnemiesShown = $("#enemyarea > .enemy-showing-info").length;
		delayLength = "";
		//if (totalEnemiesShown > 0)
		//{
			delayLength = "style=\"-webkit-animation-delay:30s;\"";
		//}
		if (!alreadyExists)
		{
			$("#enemyarea").append("<div class=\"fade-in-and-scale enemy-info-showing enemy-info-" + enemyID + "\">" + s + "</div>");
		}
	}
}

function updateBossHP(currHP)
{
	$("#enemyarea .bosscurrhp").html(currHP);
	if (currHP <= 0)
	{
		$("#enemyarea > div").addClass("shakediv");
	}
}

function clearAllTextExceptEnemies()
{
	$("#container > div").not("#enemyarea").html("").show();
}

function clearAllTextExceptScript()
{
	$("#container > div").not("#scriptarea").html("").show();
}

var itemPics = [10, 100, 101, 104, 105, 106, 107, 108, 109, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 23, 24, 25, 26, 27, 28, 29, 31, 32, 33, 38, 39, 40, 42, 45, 50, 52, 53, 54, 55, 58, 59, 62, 63, 64, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 79, 80, 82, 83, 84, 85, 86, 87, 88, 89, 9, 90, 93, 94, 95, 96, 97, 98, 99];
function addItemPic(itemNum)
{
	// not every item has a pic, so let's mark the ones that do have pics
	// if current thing isn't in itemPics, let's basically do nothing
	if (itemPics.indexOf(itemNum) != -1)
	{
		// let's not duplicate item pics in the sidebar
		var alreadyExists = $("#itempicarea .item-info-" + itemNum).html();
		if (!alreadyExists)
		{
			$("#itempicarea").append("<div class=\"item-pic item-info-" + itemNum + "\"><img src=\"images/inventory/" + itemNum + ".jpg\" /></div>");
		}
	}
	else
	{
	}	
}


$(document).ready(function() {
	$( "#container > div" ).dblclick(function() {
		$(this).html("").show();
	});
	
	$(document).on("click", "img", function() {
		 $.featherlight($(this).attr("src"));
		 //$("#devinfo").html($(this).attr("src"));
	});
});