// *********************************************************************************
// ESSENTIAL INTERNAL ROUTINES
// *********************************************************************************

// =================================================================================
// 
// =================================================================================
function replaceHtml(el, html) {
	var oldEl = typeof el === "string" ? document.getElementById(el) : el;
	var newEl = oldEl.cloneNode(false);
	newEl.innerHTML = html;
	oldEl.parentNode.replaceChild(newEl, oldEl);
	return newEl;
};


function writeHTML(id, msg)
{
	replaceHtml(id, msg);
}
	

// =================================================================================
// Copy the contents of one HTML element into another
// The destination's previous contents are overwritten
// =================================================================================
function copyHTMLElement(source, destination)
{
	$(destination).html($(source).html());
}


// =================================================================================
// Move the contents of one HTML element into another
// The source's current contents are removed
// The destination's previous contents are overwritten
// =================================================================================
function moveHTMLElement(source, destination)
{
	$(destination).html($(source).detach().html());
	//$(source).appendTo(destination);
	/*var s = $(source);
	var h = s.html();
	s.empty();
	$(destination).html(h);*/
	//$(source).detach().html(destination);
	//$(destination).show()
}


// =================================================================================
// Append content of source div to content of destination div
// Since this uses jQuery, IDs need to use #
// The copied HTML content is wrapped in a div for convenience purposes
// =================================================================================
function appendHTMLElement(source, destination)
{
	$(destination).append("<div class=\"" + $(source).attr("id") + "\">" + $(source).html() + "</div>");
}


// *********************************************************************************
// GAME-SPECIFIC ROUTINES
// *********************************************************************************


// =================================================================================
// A super-helpful way to clear the main viewing area of all text
// =================================================================================

function clearAllData()
{
	$("#container > div").html("");
	$("#container > div").show();
}




// =================================================================================
// A handy way to copy a div into the script area and have it display in a fancy way
// =================================================================================
dropTime = 0;
function displayScriptDiv(source)
{
	//window.clearTimeout(scriptCloseTimer);
	dropTime = 200;
	var s = $(source).html();
	if (s == null || s == "")
	{
		s = "<div class=\"notext\">-NO TEXT-</div>";
		dropTime = 0;
	}
	
	$("#scriptarea").hide().html(s);
	
	/*$("#scriptarea").hide().html(s);
	
	$("#scriptarea").attr("class", "");
	$("#scriptarea").attr("class", $(source).attr("class") + " " + $(source).attr("id"));*/

	$("#scriptarea").slideDown(dropTime);
}


// =================================================================================
// Close the script area in a fancy way
// =================================================================================
function closeScriptDiv()
{
	$("#scriptarea").slideUp(100);
	$("#scriptarea").removeClass("nodelay");
}
